package com.oreilly.jent.transactions.domain;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import java.rmi.RemoteException;
import java.util.HashSet;
import java.util.Set;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.RemoveException;

public abstract class PersonStatusBean implements EntityBean {
    public static Set sStatusSet;
    protected EntityContext mEntityContext;

    static {
        sStatusSet = new HashSet();
        sStatusSet.add("good");
        sStatusSet.add("bad");
    }

    public void setEntityContext(EntityContext aEntityContext) throws EJBException, RemoteException {
        mEntityContext = aEntityContext;
    }

    public void unsetEntityContext() throws EJBException, RemoteException {
        mEntityContext = null;
    }

    public void ejbRemove() throws RemoveException, EJBException, RemoteException {
    }

    public void ejbActivate() throws EJBException, RemoteException {
    }

    public void ejbPassivate() throws EJBException, RemoteException {
    }

    public void ejbLoad() throws EJBException, RemoteException {
    }

    public void ejbStore() throws EJBException, RemoteException {
    }

    public Integer ejbCreate(Person p) throws CreateException {
        return null;
    }

    public void ejbPostCreate(Person p) {
        setPerson(p);
    }

    public abstract Integer getPersonStatusId();
    public abstract void setPersonStatusId(Integer i);

    public abstract Person getPerson();
    public abstract void setPerson(Person p);

    public abstract String getStatusComment();
    public abstract void setStatusComment(String s);

    public String getStatus() {
           return getStatusInternal();
    }

    public void setStatus(String s) {
        if (!sStatusSet.contains(s)) {
            //mEntityContext.setRollbackOnly();
            throw new IllegalArgumentException(
                s + " is not a valid status! valid statuses are: " + sStatusSet
            );
        }
        setStatusInternal(s);
    }

    public abstract String getStatusInternal();
    public abstract void setStatusInternal(String s);
}

